require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ALPHA_SYSTEM_H)) {
    eval 'sub __ALPHA_SYSTEM_H () {1;}' unless defined(&__ALPHA_SYSTEM_H);
    require 'linux/config.ph';
    require 'asm/pal.ph';
    require 'asm/page.ph';
    eval 'sub BOOT_PCB () {0x20000000;}' unless defined(&BOOT_PCB);
    eval 'sub BOOT_ADDR () {0x20000000;}' unless defined(&BOOT_ADDR);
    eval 'sub BOOT_SIZE () {(16*1024);}' unless defined(&BOOT_SIZE);
    if(defined(&CONFIG_ALPHA_LEGACY_START_ADDRESS)) {
	eval 'sub KERNEL_START_PHYS () {0x300000;}' unless defined(&KERNEL_START_PHYS);
    } else {
	eval 'sub KERNEL_START_PHYS () {0x1000000;}' unless defined(&KERNEL_START_PHYS);
    }
    eval 'sub KERNEL_START () {( &PAGE_OFFSET+ &KERNEL_START_PHYS);}' unless defined(&KERNEL_START);
    eval 'sub SWAPPER_PGD () { &KERNEL_START;}' unless defined(&SWAPPER_PGD);
    eval 'sub INIT_STACK () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x2000);}' unless defined(&INIT_STACK);
    eval 'sub EMPTY_PGT () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x4000);}' unless defined(&EMPTY_PGT);
    eval 'sub EMPTY_PGE () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x8000);}' unless defined(&EMPTY_PGE);
    eval 'sub ZERO_PGE () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0xa000);}' unless defined(&ZERO_PGE);
    eval 'sub START_ADDR () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x10000);}' unless defined(&START_ADDR);
    eval 'sub PARAM () { &ZERO_PGE;}' unless defined(&PARAM);
    eval 'sub COMMAND_LINE () {(( &PARAM + 0x));}' unless defined(&COMMAND_LINE);
    eval 'sub COMMAND_LINE_SIZE () {256;}' unless defined(&COMMAND_LINE_SIZE);
    eval 'sub INITRD_START () {(* ( &PARAM+0x100));}' unless defined(&INITRD_START);
    eval 'sub INITRD_SIZE () {(* ( &PARAM+0x108));}' unless defined(&INITRD_SIZE);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/kernel.ph';
	eval 'sub __halt () {
	    eval q( &__asm__  &__volatile__ (\\"call_pal %0 #halt\\" : : \\"i\\" ( &PAL_halt)));
	}' unless defined(&__halt);
	eval 'sub switch_to {
	    local($P,$N,$L) = @_;
    	    eval q( &do { ($L) =  &alpha_switch_to( &virt_to_phys(($N)-> ($thread_info->{pcb})), ($P));  &check_mmu_context(); }  &while (0));
	}' unless defined(&switch_to);
	eval 'sub mb () {
	    eval q( &__asm__  &__volatile__(\\"mb\\": : :\\"memory\\"));
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &__asm__  &__volatile__(\\"mb\\": : :\\"memory\\"));
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &__asm__  &__volatile__(\\"wmb\\": : :\\"memory\\"));
	}' unless defined(&wmb);
	eval 'sub read_barrier_depends () {
	    eval q( &__asm__  &__volatile__(\\"mb\\": : :\\"memory\\"));
	}' unless defined(&read_barrier_depends);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub smp_mb () {
	        eval q( &mb());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &rmb());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &wmb());
	    }' unless defined(&smp_wmb);
	    eval 'sub smp_read_barrier_depends () {
	        eval q( &read_barrier_depends());
	    }' unless defined(&smp_read_barrier_depends);
	} else {
	    eval 'sub smp_mb () {
	        eval q( &barrier());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_wmb);
	    eval 'sub smp_read_barrier_depends () {
	        eval q( &barrier());
	    }' unless defined(&smp_read_barrier_depends);
	}
	eval 'sub set_mb {
	    local($var, $value) = @_;
    	    eval q( &do { $var = $value;  &mb(); }  &while (0));
	}' unless defined(&set_mb);
	eval 'sub set_wmb {
	    local($var, $value) = @_;
    	    eval q( &do { $var = $value;  &wmb(); }  &while (0));
	}' unless defined(&set_wmb);
	eval 'sub imb () {
	    eval q( &__asm__  &__volatile__ (\\"call_pal %0 #imb\\" : : \\"i\\" ( &PAL_imb) : \\"memory\\"));
	}' unless defined(&imb);
	eval 'sub draina () {
	    eval q( &__asm__  &__volatile__ (\\"call_pal %0 #draina\\" : : \\"i\\" ( &PAL_draina) : \\"memory\\"));
	}' unless defined(&draina);
	eval("sub IMPLVER_EV4 () { 0; }") unless defined(&IMPLVER_EV4);
	eval("sub IMPLVER_EV5 () { 1; }") unless defined(&IMPLVER_EV5);
	eval("sub IMPLVER_EV6 () { 2; }") unless defined(&IMPLVER_EV6);
	if(defined(&CONFIG_ALPHA_GENERIC)) {
	    eval 'sub implver () {
	        eval q(({ \'unsigned long __implver\';  &__asm__ (\\"implver %0\\" : \\"=r\\");  &__implver; }));
	    }' unless defined(&implver);
	} else {
	    if(defined(&CONFIG_ALPHA_EV4)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV4);
		}' unless defined(&implver);
	    }
	    if(defined(&CONFIG_ALPHA_EV5)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV5);
		}' unless defined(&implver);
	    }
	    if(defined( &CONFIG_ALPHA_EV6)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV6);
		}' unless defined(&implver);
	    }
	}
	eval("sub AMASK_BWX () { (1UL<<0); }") unless defined(&AMASK_BWX);
	eval("sub AMASK_FIX () { (1UL<<1); }") unless defined(&AMASK_FIX);
	eval("sub AMASK_CIX () { (1UL<<2); }") unless defined(&AMASK_CIX);
	eval("sub AMASK_MAX () { (1UL<<8); }") unless defined(&AMASK_MAX);
	eval("sub AMASK_PRECISE_TRAP () { (1UL<<9); }") unless defined(&AMASK_PRECISE_TRAP);
	eval 'sub amask {
	    local($mask) = @_;
    	    eval q(({ \'unsigned long __amask\',  &__input = ($mask);  &__asm__ (\\"amask %1,%0\\" : \\"=r\\"( &__amask) : \\"rI\\"( &__input));  &__amask; }));
	}' unless defined(&amask);
	eval 'sub __CALL_PAL_R0 {
	    local($NAME, $TYPE) = @_;
    	    eval q( &static  &inline $TYPE $NAME( &void) {  &register $TYPE  &__r0  &__asm__(\\"$0\\");  &__asm__  &__volatile__( \\"call_pal %1 # \\" $NAME :\\"=r\\" ( &__r0) :\\"i\\" ( &PAL_  $NAME) :\\"$1\\", \\"$16\\", \\"$22\\", \\"$23\\", \\"$24\\", \\"$25\\");  &return  &__r0; });
	}' unless defined(&__CALL_PAL_R0);
	eval 'sub __CALL_PAL_W1 {
	    local($NAME, $TYPE0) = @_;
    	    eval q( &static  &inline  &void $NAME($TYPE0  &arg0) {  &register $TYPE0  &__r16  &__asm__(\\"$16\\") =  &arg0;  &__asm__  &__volatile__( \\"call_pal %1 # \\"$NAME : \\"=r\\"( &__r16) : \\"i\\"( &PAL_  $NAME), \\"0\\"( &__r16) : \\"$1\\", \\"$22\\", \\"$23\\", \\"$24\\", \\"$25\\"); });
	}' unless defined(&__CALL_PAL_W1);
	eval 'sub __CALL_PAL_W2 {
	    local($NAME, $TYPE0, $TYPE1) = @_;
    	    eval q( &static  &inline  &void $NAME($TYPE0  &arg0, $TYPE1  &arg1) {  &register $TYPE0  &__r16  &__asm__(\\"$16\\") =  &arg0;  &register $TYPE1  &__r17  &__asm__(\\"$17\\") =  &arg1;  &__asm__  &__volatile__( \\"call_pal %2 # \\"$NAME : \\"=r\\"( &__r16), \\"=r\\"( &__r17) : \\"i\\"( &PAL_  $NAME), \\"0\\"( &__r16), \\"1\\"( &__r17) : \\"$1\\", \\"$22\\", \\"$23\\", \\"$24\\", \\"$25\\"); });
	}' unless defined(&__CALL_PAL_W2);
	eval 'sub __CALL_PAL_RW1 {
	    local($NAME, $RTYPE, $TYPE0) = @_;
    	    eval q( &static  &inline $RTYPE $NAME($TYPE0  &arg0) {  &register $RTYPE  &__r0  &__asm__(\\"$0\\");  &register $TYPE0  &__r16  &__asm__(\\"$16\\") =  &arg0;  &__asm__  &__volatile__( \\"call_pal %2 # \\"$NAME : \\"=r\\"( &__r16), \\"=r\\"( &__r0) : \\"i\\"( &PAL_  $NAME), \\"0\\"( &__r16) : \\"$1\\", \\"$22\\", \\"$23\\", \\"$24\\", \\"$25\\");  &return  &__r0; });
	}' unless defined(&__CALL_PAL_RW1);
	eval 'sub __CALL_PAL_RW2 {
	    local($NAME, $RTYPE, $TYPE0, $TYPE1) = @_;
    	    eval q( &static  &inline $RTYPE $NAME($TYPE0  &arg0, $TYPE1  &arg1) {  &register $RTYPE  &__r0  &__asm__(\\"$0\\");  &register $TYPE0  &__r16  &__asm__(\\"$16\\") =  &arg0;  &register $TYPE1  &__r17  &__asm__(\\"$17\\") =  &arg1;  &__asm__  &__volatile__( \\"call_pal %3 # \\"$NAME : \\"=r\\"( &__r16), \\"=r\\"( &__r17), \\"=r\\"( &__r0) : \\"i\\"( &PAL_  $NAME), \\"0\\"( &__r16), \\"1\\"( &__r17) : \\"$1\\", \\"$22\\", \\"$23\\", \\"$24\\", \\"$25\\");  &return  &__r0; });
	}' unless defined(&__CALL_PAL_RW2);
	eval 'sub IPL_MIN () {0;}' unless defined(&IPL_MIN);
	eval 'sub IPL_SW0 () {1;}' unless defined(&IPL_SW0);
	eval 'sub IPL_SW1 () {2;}' unless defined(&IPL_SW1);
	eval 'sub IPL_DEV0 () {3;}' unless defined(&IPL_DEV0);
	eval 'sub IPL_DEV1 () {4;}' unless defined(&IPL_DEV1);
	eval 'sub IPL_TIMER () {5;}' unless defined(&IPL_TIMER);
	eval 'sub IPL_PERF () {6;}' unless defined(&IPL_PERF);
	eval 'sub IPL_POWERFAIL () {6;}' unless defined(&IPL_POWERFAIL);
	eval 'sub IPL_MCHECK () {7;}' unless defined(&IPL_MCHECK);
	eval 'sub IPL_MAX () {7;}' unless defined(&IPL_MAX);
	if(defined(&CONFIG_ALPHA_BROKEN_IRQ_MASK)) {
	    undef(&IPL_MIN) if defined(&IPL_MIN);
	    eval 'sub IPL_MIN () { &__min_ipl;}' unless defined(&IPL_MIN);
	}
	eval 'sub getipl () {
	    eval q(( &rdps() & 7));
	}' unless defined(&getipl);
	eval 'sub setipl {
	    local($ipl) = @_;
    	    eval q((  &swpipl($ipl)));
	}' unless defined(&setipl);
	eval 'sub local_irq_disable () {
	    eval q( &do {  &setipl( &IPL_MAX);  &barrier(); }  &while(0));
	}' unless defined(&local_irq_disable);
	eval 'sub local_irq_enable () {
	    eval q( &do {  &barrier();  &setipl( &IPL_MIN); }  &while(0));
	}' unless defined(&local_irq_enable);
	eval 'sub local_save_flags {
	    local($flags) = @_;
    	    eval q((($flags) =  &rdps()));
	}' unless defined(&local_save_flags);
	eval 'sub local_irq_save {
	    local($flags) = @_;
    	    eval q( &do { ($flags) =  &swpipl( &IPL_MAX);  &barrier(); }  &while(0));
	}' unless defined(&local_irq_save);
	eval 'sub local_irq_restore {
	    local($flags) = @_;
    	    eval q( &do {  &barrier();  &setipl($flags);  &barrier(); }  &while(0));
	}' unless defined(&local_irq_restore);
	eval 'sub irqs_disabled () {
	    eval q(( &getipl() ==  &IPL_MAX));
	}' unless defined(&irqs_disabled);
	eval 'sub __tbi () {( &nr, &arg, &arg1...) ({  &register  &unsigned long __r16 __asm__("$16") = ( &nr);  &register  &unsigned long __r17 __asm__("$17");  &arg;  &__asm__  &__volatile__( "call_pal %3 #__tbi" :"=r" ( &__r16),"=r" ( &__r17) :"0" ( &__r16),"i" ( &PAL_tbi) , &arg1 :"$0", "$1", "$22", "$23", "$24", "$25"); });}' unless defined(&__tbi);
	eval 'sub tbi {
	    local($x,$y) = @_;
    	    eval q( &__tbi($x, &__r17=($y),\\"1\\" ( &__r17)));
	}' unless defined(&tbi);
	eval 'sub tbisi {
	    local($x) = @_;
    	    eval q( &__tbi(1, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbisi);
	eval 'sub tbisd {
	    local($x) = @_;
    	    eval q( &__tbi(2, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbisd);
	eval 'sub tbis {
	    local($x) = @_;
    	    eval q( &__tbi(3, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbis);
	eval 'sub tbiap () {
	    eval q( &__tbi(-1, ));
	}' unless defined(&tbiap);
	eval 'sub tbia () {
	    eval q( &__tbi(-2, ));
	}' unless defined(&tbia);
	if(defined(&CONFIG_SMP)) {
	}
	if(defined(&CONFIG_SMP)) {
	}
	if(defined(&CONFIG_SMP)) {
	}
	if(defined(&CONFIG_SMP)) {
	}
	eval 'sub xchg {
	    local($ptr,$x) = @_;
    	    eval q(({  &__typeof__(*)  &_x_ = ; ( &__typeof__(*))  &__xchg(,  &_x_, $sizeof{($ptr)}); }));
	}' unless defined(&xchg);
	eval 'sub tas {
	    local($ptr) = @_;
    	    eval q(( &xchg(($ptr),1)));
	}' unless defined(&tas);
	eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
	if(defined(&CONFIG_SMP)) {
	}
	if(defined(&CONFIG_SMP)) {
	}
	if(defined(&CONFIG_SMP)) {
	}
	if(defined(&CONFIG_SMP)) {
	}
	eval 'sub cmpxchg {
	    local($ptr,$o,$n) = @_;
    	    eval q(({  &__typeof__(*)  &_o_ = ;  &__typeof__(*)  &_n_ = ; ( &__typeof__(*))  &__cmpxchg(,  &_o_,  &_n_, $sizeof{($ptr)}); }));
	}' unless defined(&cmpxchg);
    }
}
1;
